#include <string.h>
#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "iolib.h"
#define PROGNAME "envdir"
#include "freedt.h"

int main(int argc, char **argv) {
	DIR *dir;

	istdinit();

	if (argc < 3)
		die("usage: envdir dir command ...");

	dir = opendir(argv[1]);
	if (!dir)
		die("unable to open directory");

	while (1) {
		struct dirent *e = readdir(dir);
		buffer filename = BUFFER, line = BUFFER;
		io *f;
		int rc;

		if (!e)
			break;

		if (strcmp(e->d_name, ".") == 0
			|| strcmp(e->d_name, "..") == 0)
			continue;

		bformat(&filename, 'c', argv[1], 'c', "/", 'c', e->d_name, 0);

		f = iopenrb(bstr(&filename));
		if (!f)
			die2(bstr(&filename), "unable to open file");
		rc = breadline(&line, f);
		if (rc < 0)
			die("read failed");
		if (rc == 0) {
			unsetenv(e->d_name);
		} else {
			btrimr(&line);
			breplacec(&line, '\n', '\0');

			if (setenv(e->d_name, bstr(&line), 1) < 0)
				die("unable to set variable");
		}
		iclose(f);
		bfree(&filename);
		bfree(&line);
	}

	execvp(argv[2], &argv[2]);
	die2(argv[2], "unable to exec");

	return 0; /* NOTREACHED */
}

